Tesseract 3.02

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Functions | Variables
boxread.h File Reference
`#include <stdio.h>`
`#include "strngs.h"`

Go to the source code of this file.

## Functions

FILE * | OpenBoxFile (const STRING &fname)
bool | ReadNextBox (int *line_number, FILE *box_file, STRING *utf8_str, TBOX *bounding_box)
bool | ReadNextBox (int target_page, int *line_number, FILE *box_file, STRING *utf8_str, TBOX *bounding_box)
bool | ParseBoxFileStr (const char *boxfile_str, int *page_number, STRING *utf8_str, TBOX *bounding_box)
void | MakeBoxFileStr (const char *unichar_str, const TBOX &box, int page_num, STRING *box_str)

## Variables

const int | kBoxReadBufSize = 1024

## Function Documentation

void MakeBoxFileStr | ( | const char * | unichar_str,
|  | const TBOX & | box,
|  | int | page_num,
|  | STRING * | box_str
| ) |  |

Definition at line 155 of file boxread.cpp.

{
*box_str = unichar_str;
box_str->add_str_int(" ", box.left());
box_str->add_str_int(" ", box.bottom());
box_str->add_str_int(" ", box.right());
box_str->add_str_int(" ", box.top());
box_str->add_str_int(" ", page_num);
}

FILE* OpenBoxFile | ( | const STRING & | fname | ) |

Definition at line 33 of file boxread.cpp.

{
STRING filename = fname;
const char *lastdot = strrchr(filename.string(), '.');
if (lastdot != NULL)
filename[lastdot - filename.string()] = '\0';
filename += ".box";
FILE* box_file = NULL;
if (!(box_file = fopen(filename.string(), "rb"))) {
CANTOPENFILE.error("read_next_box", TESSEXIT,
"Cant open box file %s",
filename.string());
}
return box_file;
}

bool ParseBoxFileStr | ( | const char * | boxfile_str,
|  | int * | page_number,
|  | STRING * | utf8_str,
|  | TBOX * | bounding_box
| ) |  |

Definition at line 105 of file boxread.cpp.

{
*bounding_box = TBOX(); // Initialize it to empty.
*utf8_str = "";
char uch[kBoxReadBufSize];
const char *buffptr = boxfile_str;
// Read the unichar without messing up on Tibetan.
// According to issue 253 the utf-8 surrogates 85 and A0 are treated
// as whitespace by sscanf, so it is more reliable to just find
// ascii space and tab.
int uch_len = 0;
while (*buffptr != '\0' && *buffptr != ' ' && *buffptr != '\t' &&
uch_len < kBoxReadBufSize - 1) {
uch[uch_len++] = *buffptr++;
}
uch[uch_len] = '\0';
if (*buffptr != '\0') ++buffptr;
int x_min, y_min, x_max, y_max;
*page_number = 0;
int count = sscanf(buffptr, "%d %d %d %d %d",
&x_min, &y_min, &x_max, &y_max, page_number);
if (count != 5 && count != 4) {
tprintf("Bad box coordinates in boxfile string!\n");
return false;
}
// Test for long space-delimited string label.
if (strcmp(uch, kMultiBlobLabelCode) == 0 &&
(buffptr = strchr(buffptr, '#')) != NULL) {
strncpy(uch, buffptr + 1, kBoxReadBufSize);
chomp_string(uch);
uch_len = strlen(uch);
}
// Validate UTF8 by making unichars with it.
int used = 0;
while (used < uch_len) {
UNICHAR ch(uch + used, uch_len - used);
int new_used = ch.utf8_len();
if (new_used == 0) {
tprintf("Bad UTF-8 str %s starts with 0x%02x at col %d\n",
uch + used, uch[used], used + 1);
return false;
}
used += new_used;
}
*utf8_str = uch;
bounding_box->set_to_given_coords(x_min, y_min, x_max, y_max);
return true; // Successfully read a box.
}

bool ReadNextBox | ( | int * | line_number,
|  | FILE * | box_file,
|  | STRING * | utf8_str,
|  | TBOX * | bounding_box
| ) |  |

Definition at line 59 of file boxread.cpp.

{
return ReadNextBox(-1, line_number, box_file, utf8_str, bounding_box);
}

bool ReadNextBox | ( | int | target_page,
|  | int * | line_number,
|  | FILE * | box_file,
|  | STRING * | utf8_str,
|  | TBOX * | bounding_box
| ) |  |

Definition at line 67 of file boxread.cpp.

{
int page = 0;
char buff[kBoxReadBufSize]; // boxfile read buffer
char *buffptr = buff;
while (fgets(buff, sizeof(buff) - 1, box_file)) {
(*line_number)++;
buffptr = buff;
const unsigned char *ubuf = reinterpret_cast<const unsigned char*>(buffptr);
if (ubuf[0] == 0xef && ubuf[1] == 0xbb && ubuf[2] == 0xbf)
buffptr += 3; // Skip unicode file designation.
// Check for blank lines in box file
while (*buffptr == ' ' || *buffptr == '\t')
buffptr++;
if (*buffptr != '\0') {
if (!ParseBoxFileStr(buffptr, &page, utf8_str, bounding_box)) {
tprintf("Box file format error on line %i; ignored\n", *line_number);
continue;
}
if (target_page >= 0 && target_page != page)
continue; // Not on the appropriate page.
return true; // Successfully read a box.
}
}
fclose(box_file);
return false; // EOF
}

## Variable Documentation

const int kBoxReadBufSize = 1024

Definition at line 30 of file boxread.h.